import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.StringTokenizer;

public class Task7 {

	public static class Node {
		Node parent;
		long height;
		Node child1;
		Node child2;

		public Node(Node parent) {
			this.parent = parent;
			if (parent == null)
				height = 1;
			else
				height = parent.height + 1;
		}

	}

	public static void main(String[] args) throws IOException {

		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		StringTokenizer st = new StringTokenizer(br.readLine());

		int n = Integer.parseInt(st.nextToken());
		long m = Integer.parseInt(st.nextToken());
		Node[] part = new Node[n];
		part[0] = new Node(null);

		st = new StringTokenizer(br.readLine());
		for (int i = 1; i < n; i++) {
			Node tmp = part[Integer.parseInt(st.nextToken()) - 1];
			part[i] = new Node(tmp);
			if (tmp.child1 != null)
				tmp.child2 = part[i];
			else
				tmp.child1 = part[i];
		}

		if (part[0].child2 == null) {
			System.out.println(m * n);
			System.exit(0);
		}

		long minSubH = (long) Math.min(subtreeHeight(part[0].child1), subtreeHeight(part[0].child2));
		long height = subtreeHeight(part[0]);
		System.out.println(height * m + minSubH + height * (m - 1));

	}

	public static long subtreeHeight(Node node) {
		if (node == null)
			return 0;
		return Math.max(subtreeHeight(node.child1), subtreeHeight(node.child2)) + 1;
	}

}
