import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.StringTokenizer;

public class Task7 {

	public static class Node {
		Node parent;
		int height;
		ArrayList<Node> children;

		public Node(Node parent) {
			this.parent = parent;
			if (parent == null)
				height = 1;
			else
				height = parent.height + 1;
			children = new ArrayList<Node>();
		}

	}

	public static void main(String[] args) throws IOException {

		BufferedReader br = new BufferedReader(new InputStreamReader(System.in));
		StringTokenizer st = new StringTokenizer(br.readLine());

		int n = Integer.parseInt(st.nextToken());
		long m = Integer.parseInt(st.nextToken());
		Node[] part = new Node[n];
		part[0] = new Node(null);

		st = new StringTokenizer(br.readLine());
		for (int i = 1; i < n; i++) {
			Node tmp = part[Integer.parseInt(st.nextToken()) - 1];
			part[i] = new Node(tmp);
			tmp.children.add(part[i]);
		}

		if (part[0].children.size() == 1) {
			System.out.println(m * n);
			System.exit(0);
		}

		part[0].children.sort(new Comparator<Node>() {
			@Override
			public int compare(Node o1, Node o2) {
				return subtreeHeight(o2) - subtreeHeight(o1);
			}
		});
		long minSubH = subtreeHeight(part[0].children.get(1));
		long height = subtreeHeight(part[0]);
		System.out.println(height * m + minSubH + height * (m - 1));

	}

	public static int subtreeHeight(Node node) {
		if (node == null)
			return 0;
		if (node.children.size() == 0)
			return 1;

		node.children.sort(new Comparator<Node>() {
			@Override
			public int compare(Node o1, Node o2) {
				return subtreeHeight(o2) - subtreeHeight(o1);
			}
		});
		return subtreeHeight(node.children.get(0)) + 1;
	}

}
